

datablock AudioProfile(bombfallSound)
{
   filename    = "./drop.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(b17idleSound)
{
   filename    = "./sounds/idle.wav";
   description = AudioDefaultLooping3d;
   preload = true;
};


datablock AudioProfile(b17throttle1Sound)
{
   filename    = "./sounds/cruise1.wav";
   description = AudioDefaultLooping3d;
   preload = true;
};








datablock ExplosionData(b17FinalExplosion)
{
   //explosionShape = "";
   lifeTimeMS = 150;

   soundProfile = vehicleExplosionSound;
   
   emitter[0] = vehicleFinalExplosionEmitter3;
   emitter[1] = vehicleFinalExplosionEmitter2;

   particleEmitter = vehicleFinalExplosionEmitter;
   particleDensity = 20;
   particleRadius = 1.0;

   debris = FlyingShapedebris;
   debrisNum = 1;
   debrisNumVariance = 0;
   debrisPhiMin = 0;
   debrisPhiMax = 360;
   debrisThetaMin = 0;
   debrisThetaMax = 20;
   debrisVelocity = 18;
   debrisVelocityVariance = 3;
   
   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "7.0 8.0 7.0";
   camShakeAmp = "10.0 10.0 10.0";
   camShakeDuration = 0.75;
   camShakeRadius = 15.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 20;
   lightStartColor = "0.45 0.3 0.1";
   lightEndColor = "0 0 0";

   //impulse
   impulseRadius = 15;
   impulseForce = 1000;
   impulseVertical = 2000;

   //radius damage
   damageRadius = 17;
   radiusDamage = 100;

   //burn the players?
   playerBurnTime = 5000;

};
datablock ProjectileData(b17FinalExplosionProjectile)
{
   directDamage        = 0;
   radiusDamage        = 0;
   damageRadius        = 0;
   explosion           = b17FinalExplosion;

   directDamageType  = $DamageType::jeepExplosion;
   radiusDamageType  = $DamageType::jeepExplosion;

   explodeOnDeath		= 1;

   armingDelay         = 0;
   lifetime            = 10;
};
datablock WheeledVehicleData(B17Vehicle)
{
	category = "Vehicles";
	displayName = " ";
	shapeFile = "./b17s.dts";

debris = FlyingShapeDebris; 
renderWhenDestroyed = true; 
	emap = true;
	minMountDist = 3;
   
   numMountPoints = 2;
   mountThread[0] = "sit";

	     mountThread[1] = "root";

   ShootonclickBomb=1;
   
   ShootonclickBomb_Hold=1;
ShootonclickBomb_ShootDelay=300;
ShootonclickBomb_ReShootDelay=300;
ShootonclickBomb_ProjectileCount=1;
ShootonclickBomb_RequiredSlot=0;
ShootonclickBomb_Sound=bombfallSound;

ShootonclickBomb_Projectile[0]=BombProjectile;
ShootonclickBomb_Position[0]="0 0 0";
ShootonclickBomb_Velocity[0]="10 0 -50";
ShootonclickBomb_Scale[0]="1 1 1";



	maxDamage = 100.00;
	destroyedLevel = 200.00;
	energyPerDamagePoint = 160;
	speedDamageScale = 1.04;
	collDamageThresholdVel = 20.0;
	collDamageMultiplier   = 0.02;

	massCenter = "0 0 0";
   //massBox = "2 5 1";

	maxSteeringAngle = 0.9785;  // Maximum steering angle, should match animation
	integration = 4;           // Force integration time: TickSec/Rate
	tireEmitter = VehicleTireEmitter; // All the tires use the same dust emitter

	// 3rd person camera settings
	cameraRoll = false;         // Roll the camera with the vehicle
	cameraMaxDist = -1;         // Far distance from vehicle
	cameraOffset = 20.5;        // Vertical offset from camera mount point
	cameraLag = 0.0;           // Velocity lag of camera
	cameraDecay = 0.75;        // Decay per sec. rate of velocity lag
	cameraTilt = 2.0;//exec("add-ons/vehicle_b17/vehicle_b17.cs");
   collisionTol = 0.1;        // Collision distance tolerance
   contactTol = 0.1;

	useEyePoint = true;	

	// defaultTire	= B17Tire;
	// defaultSpring	= B17Spring;
	// flatTire	= B17FlatTire;
	// flatSpring	= B17FlatSpring;

   //numWheels = 3;

	// Rigid Body
	mass = 200;
	density = 5.0;
	drag = 0.6;
	bodyFriction = 0.6;
	bodyRestitution = 0.6;
	minImpactSpeed = 10;        // Impacts over this invoke the script callback
	softImpactSpeed = 10;       // Play SoftImpact Sound
	hardImpactSpeed = 15;      // Play HardImpact Sound
	groundImpactMinSpeed    = 10.0;

	// Engine
	engineTorque = 12000; //4000;       // Engine power
	engineBrake = 300;         // Braking when throttle is 0
	brakeTorque = 3000;        // When brakes are applied
	maxWheelSpeed = 20;        // Engine scale by current speed / max speed

	rollForce		= 900;
	yawForce		= 600;
	pitchForce		= 1000;
	rotationalDrag		= 0.2;

	// Energy
	maxEnergy = 100;
	jetForce = 3000;
	minJetEnergy = 30;
	jetEnergyDrain = 2;

   isSled = false;

   forwardThrust		= 2000;
	reverseThrust		= 20;
	lift			= 20;
	maxForwardVel		= 35;
	maxReverseVel		= 20;
	horizontalSurfaceForce	= 130;   // Horizontal center "wing" (provides "bite" into the wind for climbing/diving and turning)
	verticalSurfaceForce	= 130; 
	rollForce		= 4000;
	yawForce		= 6000;
	pitchForce		= 6000;
	rotationalDrag		= 0.5;
	stallSpeed		= 10;



	splash = vehicleSplash;
	splashVelocity = 4.0;
	splashAngle = 67.0;
	splashFreqMod = 300.0;
	splashVelEpsilon = 0.60;
	bubbleEmitTime = 1.4;
	splashEmitter[0] = vehicleFoamDropletsEmitter;
	splashEmitter[1] = vehicleFoamEmitter;
	splashEmitter[2] = vehicleBubbleEmitter;
	mediumSplashSoundVelocity = 10.0;   
	hardSplashSoundVelocity = 20.0;   
	exitSplashSoundVelocity = 5.0;
		
	//mediumSplashSound = "";
	//hardSplashSound = "";
	//exitSplashSound = "";
	
	// Sounds
	//   jetSound = ScoutThrustSound;
	//engineSound = idleSound;
	//squealSound = skidSound;
	softImpactSound = slowImpactSound;
	hardImpactSound = fastImpactSound;
	//wheelImpactSound = slowImpactSound;

	//   explosion = VehicleExplosion;
	justcollided = 0;

   uiName = "B17G";
	rideable = true;
		lookUpLimit = 0.50;
		lookDownLimit = 0.50;

	paintable = true;
   
   damageEmitter[0] = LightDamageEmitter; 
   	damageEmitterOffset[0] = "0.0 3.0 1.0 ";
	damageLevelTolerance[0] = 0.35;
		
	
		damageEmitter[1] = HeavyDamageEmitter; 
	damageEmitterOffset[1] = "0.0 3.0 0.0 ";
	damageLevelTolerance[1] = 0.7;
	
	
   damageEmitter[2] = VehicleBurnEmitter;
	damageEmitterOffset[2] = "0.0 0.0 0.0 ";
	damageLevelTolerance[2] = 0.99;

   damageEmitter[3] = VehicleBurnEmitter;
	damageEmitterOffset[3] = "0.0 0.0 0.0 ";
	damageLevelTolerance[3] = 1.0;

   numDmgEmitterAreas = 1;
   initialExplosionProjectile = jeepExplosionProjectile;
   initialExplosionOffset = 0;         //offset only uses a z value for now

   burnTime = 4000;

   finalExplosionProjectile = B17FinalExplosionProjectile;
   finalExplosionOffset = 0.5;          //offset only uses a z value for now


   minRunOverSpeed    = 2;   //how fast you need to be going to run someone over (do damage)
   runOverDamageScale = 5;   //when you run over someone, speed * runoverdamagescale = damage amt
   runOverPushScale   = 1.2; //how hard a person you're running over gets pushed
      minb17Speed = 20;
      // Advanced Steering   minb17Speed = 20;
   steeringAutoReturn = false;
   // steeringAutoReturnRate = 0.9;
   // steeringAutoReturnMaxSpeed = 10;
   steeringUseStrafeSteering = false;
   // steeringStrafeSteeringRate = 0.1;
   
   // minContrailSpeed = 30;
};



function B17vehicle::onadd(%this,%obj)
{ 
	parent::onadd(%this,%obj);
		
	%obj.setWheelTire(0, B17tire);
	%obj.setWheelTire(1, B17tire);
	%obj.setWheelTire(2, B17tire);
			   	b17SpeedCheck(%this, %obj);
	%obj.setWheelSpring(0, B17Spring);
	%obj.setWheelSpring(1, B17Spring);
	%obj.setWheelSpring(2, B17Spring);
	
	%obj.setWheelSteering(0,0);
	%obj.setWheelSteering(1,0);
	%obj.setWheelSteering(2,-1);

	%obj.setWheelPowered(0,true);
    %obj.setWheelPowered(1,true);
	%obj.setWheelPowered(2,true);
	
	%obj.playthread(0,spin);
	
 %tl = new AIPlayer()
 {
     dataBlock = strykerTurretPlayer;
 };
 MissionCleanup.add(%t);
 %obj.mountObject(%tl, 1);
%obj.turret = %tl;

%obj.creationTime = getSimTime();
%tl.schedule(10,"rigTurret");
	    
}
datablock WheeledVehicleSpring(B17Spring)
{
   // Wheel suspension properties
   length = 0.1;			 // Suspension travel
   force = 3000; //3000;		 // Spring force
   damping = 400; //600;		 // Spring damping
   antiSwayForce = 3; //3;		 // Lateral anti-sway force
};




///////////////////////////////////////////////////////////////

datablock WheeledVehicleTire(B17Tire)
{
   // Tires act as springs and generate lateral and longitudinal
   // forces to move the vehicle. These distortion/spring forces
   // are what convert wheel angular velocity into forces that
   // act on the rigid body.
   shapeFile = "./jeeptire.dts";
	
	mass = 10;
    radius = 1;
    staticFriction = 5;
   kineticFriction = 5;
   restitution = 0.5;	

   // Spring that generates lateral tire forces
   lateralForce = 18000;
   lateralDamping = 4000;
   lateralRelaxation = 0.01;

   // Spring that generates longitudinal tire forces
   longitudinalForce = 14000;
   longitudinalDamping = 2000;
   longitudinalRelaxation = 0.01;
};

datablock ExplosionData(BombExplosion)
{
   explosionShape = "";
   soundProfile = rocketExplodeSound;

   lifeTimeMS = 150;



   particleEmitter = gravityRocketExplosionEmitter;
   particleDensity = 10;
   particleRadius = 0.2;

   emitter[0] = gravityRocketExplosionRingEmitter;
   emitter[1] = gravityRocketExplosionChunkEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "3.0 10.0 3.0";
   camShakeDuration = 0.5;
   camShakeRadius = 20.0;

   // Dynamic light
   lightStartRadius = 5;
   lightEndRadius = 20;
   lightStartColor = "1 1 0 1";
   lightEndColor = "1 0 0 0";

   damageRadius = 20;
   radiusDamage = 170;

   impulseRadius = 15;
   impulseForce = 5000;

   playerBurnTime = 5000;
};



datablock ProjectileData(BombProjectile)
{
   projectileShapeName = "./Bomb2.dts";
   directDamage        = 100;
   directDamageType = $DamageType::BombDirect;
   radiusDamageType = $DamageType::BombRadius;
   impactImpulse	   = 1000;
   verticalImpulse	   = 1000;
   explosion           = bombExplosion;
   //particleEmitter     = rocketTrailEmitter;

   brickExplosionRadius = 20;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 50;             
   brickExplosionMaxVolume = 60;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 120;  //max volume of bricks that we can destroy if they aren't connected to the ground (should always be >= brickExplosionMaxVolume)

   //sound = rocketLoopSound;

   muzzleVelocity      = 120;
   velInheritFactor    = 1.0;

   armingDelay         = 0;
   lifetime            = 1023000;
   fadeDelay           = 1023000;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = true;
   gravityMod = 1.0;

   hasLight    = true;
   lightRadius = 5.0;
   lightColor  = "1 0.5 0.0";

   explodeOnDeath = 1;

   uiName = "Bomb"; //naming it this way so it's next to the rocket in the alphabetized list
};
function b17Vehicle::onImpact(%this,%obj,%data)
{
	%speed = vectorLen(%obj.getVelocity());
	if(%speed > %obj.dataBlock.minb17Speed)

		%trans = %obj.getTransform();

	%p = new Projectile()
	{
		dataBlock = jeepFinalExplosionProjectile;
		initialVelocity  = "0 0 0";
		initialPosition  = %trans;
		sourceObject     = %obj;
		sourceSlot       = 0;
		client           = %obj.client;
	};
	MissionCleanup.add(%p);
	         if(%obj.destroyed)
            return;
         %obj.setDamageLevel(%this.maxDamage);
         %obj.destroyed = 1;
         %obj.schedule(10,"finalExplosion");
         if(isObject(%obj.spawnBrick.client.minigame))
            %respawn = %obj.spawnBrick.client.minigame.vehicleReSpawnTime;
         %obj.spawnBrick.schedule(%respawn,"spawnVehicle");

	
}
function Player::rigTurret(%obj)
{
   if(%obj.dataBlock !$= StrykerTurretPlayer)
	   return;

   if(!isObject(%obj))
	   return;

   %parent = %obj.getObjectMount();
   if(!isObject(%parent))
	   return;

   %obj.spawnBrick = %parent.spawnBrick;
   %obj.brickGroup = %parent.brickGroup;
}

function b17Vehicle::onRemove(%this,%obj)
{
   if(isObject(%obj.turret))
	   %obj.turret.delete();
}

function b17TurretPlayer::onDriverLeave(%this,%obj)
{
   %obj.setTransform("0 0 0 0 0 0 0");
}

package b17Package
{
   function Player::burn(%obj,%time)
   {
      if(%obj.dataBlock $= StrykerTurretPlayer)
         return;
      else
         Parent::burn(%obj,%time);
   }

   function ShapeBase::setNodeColor(%obj,%node,%color)
   {
      Parent::setnodecolor(%obj,%node,%color);
      if(isObject(%obj.turret))
      {
         %obj.turret.setNodeColor("ALL",%color);
      }
   }

   function b17Vehicle::Damage(%this,%obj,%source,%pos,%amm,%type)
   {
      if((%obj.getDamageLevel()+%amm) >= %this.maxDamage)
      {
         if(%obj.destroyed)
            return;

         %obj.setNodeColor("ALL","0 0 0 1");
         if(isObject(%obj.turret))
         {
            %obj.turret.delete();
            %p = new Projectile()
            {
               dataBlock = b17TurretExplosionProjectile;
               initialPosition = vectorAdd(%obj.getPosition(),"0 0" SPC %this.initialExplosionOffset);
               initialVelocity = "0 0 1";
               client = %obj.lastDamageClient;
               sourceClient = %obj.lastDamageClient;
            };
            MissionCleanup.add(%p);
         }
         else
         {
            %p = new Projectile()
            {
               dataBlock = b17ExplosionProjectile;
               initialPosition = vectorAdd(%obj.getPosition(),"0 0" SPC %this.initialExplosionOffset);
               initialVelocity = "0 0 1";
               client = %obj.lastDamageClient;
               sourceClient = %obj.lastDamageClient;
            };
            MissionCleanup.add(%p);
         }
         if(%obj.destroyed)
            return;

         %obj.setDamageLevel(%this.maxDamage);
         %obj.destroyed = 1;
         %obj.schedule(%this.burnTime,"finalExplosion");
         if(isObject(%obj.spawnBrick.client.minigame))
            %respawn = %obj.spawnBrick.client.minigame.vehicleReSpawnTime;
         %obj.spawnBrick.schedule(%respawn,"spawnVehicle");
      }
      else
         Parent::Damage(%this,%obj,%source,%pos,%amm,%type);
   }

   function Player::emote(%obj,%emote)
   {
      if(%obj.dataBlock $= StrykerTurretPlayer)
	      return;
      Parent::emote(%obj,%emote);
   }

   function b17TurretPlayer::onDamage(%this,%obj,%ammount)
   {
      if(%obj.dataBlock $= StrykerTurretPlayer)
         return;
	   Parent::onDamage(%this,%obj,%ammount);
   }



   function b17TurretPlayer::onDisabled(%this,%obj,%state)
   {


			%p = new Projectile()
				{
				dataBlock = b17TurretExplosionProjectile;
				initialPosition = vectorAdd(%obj.getObjectMount().getPosition(),"0 0" SPC %obj.getObjectMount().dataBlock.initialExplosionOffset);
				initialVelocity = "0 0 1";
				client = %obj.lastDamageClient;
				sourceClient = %obj.lastDamageClient;
				};
			MissionCleanup.add(%p);
			%obj.schedule(10,"delete");
			%player = %obj.getMountedObject(0);
			if(isObject(%player))
			{
				%obj.getObjectMount().schedule(10,"mountObject",%player,2);
			}
		
		
   }

   function b17TurretPlayer::Damage(%this,%obj,%source,%pos,%amm,%type)
   {
      //scale the damage ammount as if this was a vehicle
      %amm *= $Damage::VehicleDamageScale[%type];

      if(%obj.getDamageLevel()+%amm > %this.maxDamage)
         %obj.setDamageLevel(%this.maxDamage);
      else
         Parent::Damage(%this,%obj,%source,%pos,%amm,%type);
   }

   function armor::onMount(%this,%obj,%col,%slot)
   {
      Parent::onMount(%this,%obj,%col,%slot);
      if(%col.getDataBlock() == b17Vehicle.getId())
      {
         if(%slot $= 1)
         {
            %obj.setLookLimits(1,0);
         }
      }
      else if(%col.getDataBlock() == StrykerTurretPlayer.getId())
      {
         %client = %obj.client;
         if(isObject(%client))
            ServerCmdUnUseTool(%client);
      }
   }

  
};
activatepackage(b17Package);

function b17SpeedCheck(%this, %obj)
{


	if(!isObject(%obj))
		return;

	%vehicle = %obj;
%slot = 0; //Play the sound in the driver's spot
	%speed = vectorLen(%obj.getVelocity());

	if(%speed < 0) //Keeps throwing random negative numbers when train is at dead stop
	    %speed = 0;

	if(%speed < 10)
	    %vehicle.playAudio(%slot, b17idleSound);

	else if(%speed < 30)
	    %vehicle.playAudio(%slot, b17throttle1Sound);




	    

	schedule(500,0,"b17SpeedCheck",%this,%obj);
}
